cf1250G(贪心)

题目链接

https://codeforces.com/contest/1250/problem/G

题意

两个人玩 $n$ 轮游戏,初始每人的分数 $x,y$ 为 $0$ ,每轮 $x$ 加上 $a_i$ ,$y$ 加上 $b_i$ ,若有人分数超过 $k$ 则该人输,同时超过 $k$ 为平局

$x$ 在每轮可以选择一次操作,令 $x’=\max(0,x-y),y’=\max(0,y-x)$ ,问最少操作次数,使得 $x$ 获胜

题解

由于在第 $i$ 轮操作的时候后,当前的分数是固定的,考虑维护 $d_i$ 表示在 $i$ 轮操作时保证 $x$ 不输的最少操作次数

由于 $d_i$ 是单调递增的,所以维护的时候上一次操作应该尽量靠前,因此可以直接二分决策点。。

然后维护出 $d_i$ 之后考虑在那个地方获胜,然后就能推出操作时的截断长度区间,根据这个区间直接二分,也是取靠前的决策点。。




代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
/**
*         ┏┓    ┏┓
*         ┏┛┗━━━━━━━┛┗━━━┓
*         ┃       ┃  
*         ┃   ━    ┃
*         ┃ >   < ┃
*         ┃       ┃
*         ┃... ⌒ ...  ┃
*         ┃ ┃
*         ┗━┓ ┏━┛
*          ┃ ┃ Code is far away from bug with the animal protecting          
*          ┃ ┃ 神兽保佑,代码无bug
*          ┃ ┃           
*          ┃ ┃       
*          ┃ ┃
*          ┃ ┃           
*          ┃ ┗━━━┓
*          ┃ ┣┓
*          ┃ ┏┛
*          ┗┓┓┏━━━━━━━━┳┓┏┛
*           ┃┫┫ ┃┫┫
*           ┗┻┛ ┗┻┛
*/

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<stack>
#include<cmath>
#include<set>
#include<bitset>
#include<complex>
#include<cstdlib>
#include<assert.h>
#define inc(i,l,r) for(int i=l;i<=r;i++)
#define dec(i,l,r) for(int i=l;i>=r;i--)
#define link(x) for(edge *j=h[x];j;j=j->next)
#define mem(a) memset(a,0,sizeof(a))
#define ll long long
#define mid (x+y>>1)
#define eps 1e-8
#define succ(x) (1ll<<(x))
#define lowbit(x) (x&(-x))
#define sqr(x) ((x)*(x))
#define NM 200005
#define nm 131072
using namespace std;
const double pi=acos(-1);
const int inf=998244353;
ll read(){
ll x=0,f=1;char ch=getchar();
while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
return f*x;
}


int ans,n,_ans,p[NM],d[NM];
ll m,a[NM],b[NM],c[NM];

int main(){
int _=read();while(_--){
n=read();m=read();
inc(i,1,n)a[i]=read()+a[i-1];
inc(i,1,n)b[i]=read()+b[i-1];
inc(i,1,n)c[i]=min(a[i],b[i]);
inc(i,1,n){
int t=upper_bound(c,c+i,a[i]-m)-c;
if(t==i){n=i-1;break;}
d[i]=d[t]+1;
p[i]=t;
}
ans=inf;_ans=0;
//inc(i,1,n)printf("%d ",p[i]);putchar('\n');
inc(i,1,n)if(a[i]<b[i]){
int t=p[i];
if(b[i]-c[t]>=m&&d[t]<ans)ans=d[t],_ans=t;
}
if(ans<inf)printf("%d\n",ans);
else{
printf("-1\n");
continue;
}
for(int t=_ans;t;t=p[t]){
if(t!=_ans)putchar(' ');
printf("%d",t);
}
putchar('\n');
}
return 0;
}